//+------------------------------------------------------------------+
//|                                                      JMA_WPR.mq4 |
//|                                                     JMA - Spiggy |
//|                                                       Dm_35 2008 |
//|  modJMA Sto KD                     http://www.fxexpert.ru/forum/ |
//+------------------------------------------------------------------+
//mod 
#property copyright "Dm_35"
#property link      "dm34@mail.ru"

/////////////STO HULL MOVING AVERAGE  2013 

//----
#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Red
#property indicator_color2     Orange
#property indicator_levelcolor DarkSlateGray
 
#property indicator_minimum 0
#property indicator_maximum 100

//---- input parameters
extern int    StoKPeriod                = 24;

extern int    MALen                    = 13;
extern int    MAType                 = 3;
extern double   Hspeed          =2;
extern int    SigMa_Period              = 9;
extern int    SigMa_Method              = 3;
 int    BarCount                  = 500;

extern double levelOb                   = 75;
extern double levelOs                   = 25;

extern bool   alertsOn                  = 0;
extern bool   alertsOnObOsSigCross      = false;
extern bool   alertsOnSignalCross       = false;
extern bool   alertsOnLeavingObOs       = true;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = false;
extern bool   alertsNotify              = false;
extern bool   alertsEmail               = false;

extern bool   arrowsVisible             = true;
extern bool   arrowsOnObOsSigCross      = true;
extern color  arrowsObOsSigCrossUpColor = LimeGreen;
extern color  arrowsObOsSigCrossDnColor = Red;
extern int    arrowsObOsSigCrossUpCode  = 217;
extern int    arrowsObOsSigCrossDnCode  = 218;
extern int    arrowsObOsSize            = 3;

extern bool   arrowsOnSignCross        = true;
extern color  arrowsSignCrossUpColor   = DeepSkyBlue;
extern color  arrowsSignCrossDnColor   = PaleVioletRed;
extern int    arrowsSignCrossUpCode    = 159;
extern int    arrowsSignCrossDnCode    = 159;
extern int    arrowsSignCrossSize      = 3;

extern bool   arrowsOnLeavingObOs      = true;
extern color  arrowsLeavingObOsUpColor = DodgerBlue;
extern color  arrowsLeavingObOsDnColor = OrangeRed;
extern int    arrowsLeavingObOsUpCode  = 241;
extern int    arrowsLeavingObOsDnCode  = 242;
extern int    arrowsLeavingObOsSize    = 3;

extern string arrowsIdentifier         = "Hull mastoch arrows1";
extern double arrowsUpperGap           = 1.5;
extern double arrowsLowerGap           = 1.5;






//---- buffers
double Buffer1[];
double Buffer2[];
double trend1[];
double trend2[];
double trend3[];
double series[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Buffer1); //STO
   SetIndexBuffer(1,Buffer2);//STOMA
   SetIndexBuffer(2,trend1);
   SetIndexBuffer(3,trend2);
   SetIndexBuffer(4,trend3);
   SetIndexBuffer(5,series);
    
   
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
  
   IndicatorShortName("STO HULL MA ("+StoKPeriod+" ; "+ MALen+ ", "+MAType+")");

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   deleteArrows();

return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   //
   //
   //
   //
   //
   
   //int jj=0;
   //int ii=0;
   int shift=0;
   //double series[];
//----
   
   

//----
  // double list[127];
  // double ring1[127];
  // double ring2[10];
  // double buffer[61];
//----
  // ArrayInitialize(list,0);
  // ArrayInitialize(ring1,0);
  // ArrayInitialize(ring2,0);
   //ArrayInitialize(buffer,0);
//----

     
   
  for( shift=BarCount;shift>=0;shift-- )
  {
      
      series[shift]=iStochastic(NULL,0,StoKPeriod,1,1,0,0,0,shift);
      }
       
    
        
 
 
         
          
         
       for( shift=BarCount;shift>=0;shift-- )   
             
      {       
           
      Buffer1[shift]=iMAOnArray(series,Bars,MathFloor(MALen/Hspeed) ,0,MAType,shift)*2-iMAOnArray(series,Bars,MALen,0,MAType,shift);//iMA(NULL,0,MathFloor(BandsPeriod/speed),BandsShift,MODE_Band,PRICE,i)*2-iMA(NULL,0,BandsPeriod,BandsShift,MODE_Band,PRICE,i);
    }
        
   
        
     for( shift=BarCount;shift>=0;shift-- )
     {
        Buffer2[shift]=iMAOnArray(Buffer1,0,SigMa_Period,0,SigMa_Method,shift);
        trend1[shift] = 0;
        trend2[shift] = trend2[shift+1];
        trend3[shift] = 0;
        if (Buffer1[shift]<levelOs && Buffer1[shift]>Buffer2[shift])                          trend1[shift] = 1;
        if (Buffer1[shift]>levelOb && Buffer1[shift]<Buffer2[shift])                          trend1[shift] =-1;
        
        if (Buffer1[shift]>Buffer2[shift]&&Buffer1[shift]>levelOs&&Buffer1[shift]<levelOb)    trend2[shift] = 1; 
        if (Buffer1[shift]<Buffer2[shift]&&Buffer1[shift]>levelOs&&Buffer1[shift]<levelOb)    trend2[shift] =-1; 
            
        if (Buffer1[shift]>levelOb)                                                           trend3[shift] = 1;
        if (Buffer1[shift]<levelOs)                                                           trend3[shift] =-1;  
        manageArrow(shift);
   }
   manageAlerts();
return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":3:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnObOsSigCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i] == 1) drawArrow("1",0.5,i,arrowsObOsSigCrossUpColor,arrowsObOsSigCrossUpCode,arrowsObOsSize,false);
         if (trend1[i] ==-1) drawArrow("1",0.5,i,arrowsObOsSigCrossDnColor,arrowsObOsSigCrossDnCode,arrowsObOsSize, true);
      } 
      if (arrowsOnSignCross && trend2[i] != trend2[i+1])
      {
         if (trend2[i] == 1) drawArrow("2",1,i,arrowsSignCrossUpColor,arrowsSignCrossUpCode,arrowsSignCrossSize,false);
         if (trend2[i] ==-1) drawArrow("2",1,i,arrowsSignCrossDnColor,arrowsSignCrossDnCode,arrowsSignCrossSize, true);
      }
      if (arrowsOnLeavingObOs && trend3[i] != trend3[i+1])
      {
         if (trend3[i+1] == -1 && trend3[i] !=-1) drawArrow("3",1.5,i,arrowsLeavingObOsUpColor,arrowsLeavingObOsUpCode,arrowsLeavingObOsSize,false);
         if (trend3[i+1] ==  1 && trend3[i] != 1) drawArrow("3",1.5,i,arrowsLeavingObOsDnColor,arrowsLeavingObOsDnCode,arrowsLeavingObOsSize, true);
      }                                  
   }         
}       

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,12,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnObOsSigCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," HullMA_Stochastic crossed signal inside OS zone");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," HullMA_Stochastic crossed signal inside OB zone");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," HullMA_Stochastic crossed signal outside OS/OB zone");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," HullMA_Stochastic crossed signal outside OS/OB zone");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnLeavingObOs && trend3[whichBar] != trend3[whichBar+1])
         {
            if (trend3[whichBar+1] == -1 && trend3[whichBar] !=-1) doAlert(time3,mess3,whichBar," HullMA_Stochastic leaving oversold zone");
            if (trend3[whichBar+1] ==  1 && trend3[whichBar] != 1) doAlert(time3,mess3,whichBar," HullMA_Stochastic leaving overbought zone");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," sto_HullMA_Stochastic_KDSL "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}